
' pieces_old.bas

#ifndef resPath
#define resPath ".\bitmap\"
#endif

type tChessPieces
  as integer pictures(39, 39)
  as string placement
  declare sub Initialize()
  declare sub DrawPiece(byval as integer, byval as integer, byval as integer, byval as integer)
  declare sub DrawBoard(byval as integer, byval as integer, byval as string, byval as integer = 0, byval as integer = 0)
end type

sub tChessPieces.Initialize()
  dim as integer i, j, k
  dim as integer f = freefile
  dim s as string
  for j = 0 to 39
    for k = 0 to 39
      pictures(j, k) = 0
    next k
  next j
  if open(resPath & "pieces.txt" for input as #f) = 0 then
    for i = 0 to 20
      for j = 0 to 39
        line input #f, s
        for k = 0 to 39
          if s[k] = asc("1") then
            pictures(k, j) = pictures(k, j) or (1 shl i)
          end if
        next k
      next j
    next i
    close #f
  end if
  placement = string(64, "x")
end sub

sub tChessPieces.DrawPiece(byval xo as integer, byval yo as integer, byval index as integer, byval blackSquare as integer)
  dim as integer x, y
  if index < 0 then index = abs(index) + 7
  if blackSquare then
    dim index2 as integer = index mod 7 + 14
    for x = 0 to 39
      for y = 0 to 39
        if (pictures(x, y) and ((1 shl index) or (1 shl index2))) > 0 then
          pset(xo + x, yo + y)
        else
          preset(xo + x, yo + y)
        end if
      next y
    next x
  else
    for x = 0 to 39
      for y = 0 to 39
        if (pictures(x, y) and (1 shl index)) > 0 then
          pset(xo + x, yo + y)
        else
          preset(xo + x, yo + y)
        end if
      next y
    next x
  end if
end sub

sub tChessPieces.DrawBoard( _
  byval xo as integer, _
  byval yo as integer, _
  byval aPlacement as string, _
  byval aFlipBoard as integer = 0, _
  byval redrawAll as integer = 0 _
)
  dim symbols as string = "kqrbnp PNBRQK"
  dim i as integer
  for i = 0 to 63
    if (aPlacement[i] <> placement[i]) or redrawAll then
      if not aFlipBoard then
        DrawPiece( _
          40 * (i mod 8) + xo, _
          40 * (i \ 8) + yo, _
          instr(symbols, chr(aPlacement[i])) - 7, _
          (i mod 8 + i \ 8) mod 2 = 1 _
        )
      else
        DrawPiece( _
          40 * (7 - (i mod 8)) + xo, _
          40 * (7 - (i \ 8)) + yo, _
          instr(symbols, chr(aPlacement[i])) - 7, _
          (i mod 8 + i \ 8) mod 2 = 1 _
        )
      end if
      placement[i] = aPlacement[i]
    end if
  next i
end sub
